@echo off
setlocal
set IMGAPP_ARGS=

if [%1] == [/?] goto Usage
if [%1] == [-?] goto Usage
if [%2] == [] goto Usage
if [%3] == [] goto Usage

set IMGAPP_ARGS=%1 %2 %3 +StrictSettingPolicies

if [%4] NEQ [] (
  if [%5] == [] goto Usage
  set IMGAPP_ARGS=%IMGAPP_ARGS% /OEMCustomizationXML:%4 /OEMVersion:%5
)

if [%6] NEQ [] goto Usage

REM call ImageApp with the specified parameters
call ImageApp %IMGAPP_ARGS%

if errorlevel 1 goto Error


REM call DevNodeClean

if "%ProgramW6432%"=="" (
   REM run x86
   call DeviceNodeCleanup.x86.exe
) ELSE (
   REM run x64
   call DeviceNodeCleanup.x64.exe
)

echo Image successfully created at %1
goto End


:Usage
echo Usage: ImgGen OutputFile OEMInputXML MSPackageRoot OEMCustomizationXML OEMCustomizationVer
echo    OutputFile............ Required, path to the image to be created. 
echo    OEMInputXML........... Required, path to the OEM Input XML file.
echo    MSPackageRoot......... Required, path to the Microsoft Package Root
echo    OEMCustomizationXML    Optional, path to the OEM customization XML file
echo    OEMCustomizationVer    Required if OEMCustomizationXML is specified, version for OEM customization package
echo    [/?].................. Displays this usage string. 
echo    Example:
echo        ImgGen Flash.ffu OEMInput.xml "c:\Program Files (x86)\Windows Phone Kits\8.1\MSPackages" OEMCustomization.XML 8.0.0.1

goto End

:Error
echo "ImageApp %IMGAPP_ARGS%" failed with error %ERRORLEVEL%
exit /b 1

:End
